// javascript-obfuscator:enable
type HighlightPublicInterface = {
    init: (orgID: number, debug?: boolean) => void;
    _initScript: (scriptPath?: string) => HTMLScriptElement;
    identify: (identify: string, scriptPath: string) => void;
};
interface Window {
    highlight_obj: any;
    H: HighlightPublicInterface;
    Highlight: any;
}

var script: HTMLScriptElement;
var highlight_obj: any;

window.H._initScript = (
    scriptPath: string = 'https://static.highlight.run/index.js'
) => {
    var script = document.createElement('script');
    script.setAttribute('src', scriptPath + '?' + new Date().getMilliseconds());
    script.setAttribute('type', 'text/javascript');
    document.getElementsByTagName('head')[0].appendChild(script);
    return script;
};

script = window.H._initScript();

const onHighlightReady = (func: () => void) => {
    var interval = setInterval(function () {
        if (highlight_obj && highlight_obj.ready) {
            clearInterval(interval);
            func();
        }
    }, 200);
};

window.H.init = (orgID: number, debug: boolean = false) => {
    script.addEventListener('load', () => {
        highlight_obj = new window.Highlight(debug);
        highlight_obj.initialize(orgID);
    });
};

window.H.identify = (identifier: string, obj: any) => {
    onHighlightReady(() => highlight_obj.identify(identifier, obj));
};
